<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'NewCaseStudyQuote',
  props: {
    data: {
      type: Object,
      required: true,
    },
    totalSlides: {
      type: Number,
      required: true,
      default: 0,
    },
    slideIndex: {
      type: Number,
      required: true,
      default: 0,
    },
    currentIndex: {
      type: Number,
      required: true,
      default: 0,
    },
  },
});
</script>

<template>
  <div>
    <div class="case-study-quote__link" :data-ga-slide="data.data_ga_name">
      <SlpTypography
        v-if="data.header"
        tag="h2"
        variant="heading3-bold"
        class="case-study-quote__header"
        ><a
          :href="data.url"
          :data-ga-name="data.data_ga_name"
          :data-ga-location="data.data_ga_location"
          >{{ data.header }}</a
        >
      </SlpTypography>
      <SlpRow class="case-study-quote">
        <SlpColumn
          class="case-study-quote__main-text"
          :class="{
            'case-study-quote__main-text--single-quote':
              !data.statistic_samples,
          }"
          :cols="data.statistic_samples ? 9 : 12"
        >
          <div class="case-study-quote__title-img">
            <nuxt-img
              v-if="data.main_img"
              :src="data.main_img.url"
              size
              :alt="data.main_img.alt"
              loading="lazy"
              format="webp"
              quality="99"
            />
          </div>
          <div class="case-study-quote__body-wrapper">
            <a
              :href="data.url"
              :data-ga-name="data.data_ga_name"
              :data-ga-location="data.data_ga_location"
            >
              <SlpTypography
                class="case-study-quote__body"
                :class="{ 'top-align': data.align_top }"
                tag="p"
                variant="quotes"
              >
                {{ data.quote }}</SlpTypography
              >
              <div v-if="data.url">
                <SlpButton
                  variant="tertiary"
                  class="case-study-quote__read-more"
                >
                  <SlpTypography tag="span" variant="quotes">
                    {{ data.cta_text ?? 'Read More' }}
                  </SlpTypography>
                  <SlpIcon
                    name="chevron-lg-right"
                    variant="product"
                    size="sm"
                    alt="Chevron Right Icon"
                  />
                </SlpButton>
              </div>
            </a>

            <div class="case-study-quote__text-footer">
              <div class="case-study-quote__text-footer-logo">
                <nuxt-img
                  v-if="data.logo"
                  :src="data.logo.url"
                  :alt="data.logo.alt"
                  loading="lazy"
                  format="webp"
                  quality="99"
                />
              </div>
              <div class="case-study-quote__text-footer-role">
                <SlpTypography
                  class="case-study-quote__author"
                  tag="p"
                  variant="body3-bold"
                  >{{ data.author }}
                </SlpTypography>
                <span
                  class="case-study-quote__role"
                  v-html="$md.render(data.role)"
                >
                </span>
              </div>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn
          v-if="data.statistic_samples"
          :cols="3"
          class="case-study-quote__number-samples"
        >
          <div
            v-for="box in data.statistic_samples"
            :key="`${box.data.subtitle}`"
            class="sample-box"
          >
            <SlpTypography
              class="sample-box__highlighted"
              tag="span"
              variant="heading2-bold"
              >{{ box.data.highlight }}
            </SlpTypography>
            <SlpTypography tag="span" variant="heading5"
              >{{ box.data.subtitle }}
            </SlpTypography>
          </div>
        </SlpColumn>
      </SlpRow>
    </div>
  </div>
</template>

<style scoped lang="scss">
.case-study-quote {
  flex-wrap: nowrap;
  flex-direction: row;
  align-items: stretch;
  gap: $spacing-24;
  margin-top: $spacing-48;

  @media (max-width: $breakpoint-lg) {
    flex-wrap: nowrap;
    flex-direction: column;
    margin-top: $spacing-16;
    gap: $spacing-8;
  }

  &__body-wrapper {
    padding: $spacing-48 $spacing-32 $spacing-48 0;
    color: $color-primary-200;

    a {
      color: $color-primary-200;
    }

    &:hover,
    &:focus,
    &:active {
      .case-study-quote__read-more {
        text-decoration-color: $color-text-link-100 !important;
        :deep .slp-icon {
          transform: translateX(8px) !important;
        }
      }
    }

    @media (max-width: $breakpoint-lg) {
      padding: 0;
    }
  }

  &__body {
    a,
    a:hover,
    a:focus,
    a:active,
    a:visited {
      color: $color-primary-200;
      text-decoration: none;
    }
    &.top-align {
      padding: 0 $spacing-16 $spacing-24 0;
    }

    @media (max-width: $breakpoint-lg) {
      padding-top: $spacing-16;
      font-size: 16px;
      line-height: 24px;
    }
  }

  &__author {
    padding-bottom: $spacing-16;
  }

  &__role {
    &:deep p {
      font-size: 14px;
      line-height: 20px;
    }
  }

  &__main-img {
    min-width: 250px;
    margin-right: $spacing-64;

    img {
      max-width: 100%;
      border-radius: 0 0 100px 0;
      object-fit: cover;
    }
  }

  &__main-text {
    flex: 1;
    background: $color-surface-50;
    display: flex;
    border-radius: 8px 0px 0 8px;
    border: 1px solid $color-surface-200;
    box-sizing: border-box;
    margin-left: 16px;

    &--single-quote {
      border-bottom-right-radius: 64px;
    }

    @media (max-width: $breakpoint-lg) {
      width: 100%;
      max-width: 100%;
      margin-left: 0;
      flex-direction: column;
      padding: $spacing-32 $spacing-16;
    }
  }

  &__text-footer {
    display: flex;
    margin-top: $spacing-32;

    &-role {
      font-size: 14px;
    }
    p {
      padding: 0;
    }

    &-logo {
      height: 60px;
      margin-right: $spacing-24;

      img {
        height: 100%;
      }
    }

    @media (max-width: $breakpoint-lg) {
      margin-top: $spacing-16;
      max-width: 300px;
      flex-wrap: wrap;

      &-logo {
        margin-right: $spacing-16;
        margin-bottom: $spacing-16;
      }
    }

    @media (max-width: $breakpoint-sm) {
      &-logo img {
        height: auto;
        max-width: 100%;
        max-height: 100%;
      }
    }
  }

  &__title-img {
    min-width: 230px;
    position: relative;

    img {
      width: 220px;
      position: absolute;
      top: -$spacing-16;
      left: -$spacing-16;
      border-bottom-right-radius: 66px;
      box-shadow: #d1d0d3 0px 16px 50px -24px;
    }

    &::after {
      display: block;
      content: '';
      width: 110px;
      height: 110px;
      position: absolute;
      right: 21px;
      top: -21px;
      border-radius: 0 $border-radius-4;
      border-top: 1px solid $color-accent-400;
      border-right: 1px solid $color-accent-400;
    }

    @media (max-width: $breakpoint-lg) {
      img {
        width: 220px;
        position: relative;
        top: auto;
        left: auto;
      }

      &::after {
        top: -5px;
        left: 115px;
      }
    }
  }

  &__number-samples {
    display: flex;
    flex-direction: column;

    @media (max-width: $breakpoint-lg) {
      width: 100%;
      max-width: 100%;
    }
    .sample-box {
      flex-direction: column;
      display: flex;
      justify-content: center;
      flex: 1;
      background-color: $color-surface-50;
      margin-bottom: $spacing-16;
      padding: 18px $spacing-32;
      border: 1px solid $color-surface-200;

      &:last-of-type {
        margin-bottom: 0;
        border-bottom-right-radius: 60px;
      }

      &__highlighted {
        color: $color-text-link-100;
      }

      @media (max-width: $breakpoint-lg) {
        padding: $spacing-32 16px;
        margin-bottom: $spacing-8;
      }
    }
  }

  &__slider-controller {
    display: flex;
    align-items: center;
    margin-top: 32px;

    &-bullet {
      width: 10px;
      height: 10px;
      background-color: $color-surface-300;
      border-radius: $border-radius-24;
      margin: 0 $spacing-8;

      &--active {
        background: $color-surface-700;
      }
    }

    @media (max-width: $breakpoint-lg) {
      margin-top: 16px;
    }
  }

  &__footer {
    justify-content: flex-start;
    position: relative;
    height: 50px;

    .slp-btn {
      position: absolute;
      top: 16px;
    }

    @media (max-width: $breakpoint-md) {
      flex-direction: column-reverse;
    }
  }
  &__header {
    a {
      color: $color-primary-200;
    }
  }
  &__read-more {
    font-style: normal !important;
    color: $color-text-link-100;

    :deep span {
      font-style: normal !important;
    }
    &:hover,
    &:focus,
    &:active {
      text-decoration-color: transparent !important ;

      :deep .slp-icon {
        transform: none !important;
      }
    }
  }
}

.case-study-quote__link {
  color: $color-text-300;
  padding-bottom: 48px;

  @media (max-width: $breakpoint-lg) {
    padding-bottom: 0;
  }
}
</style>
